diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-default-filters.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-default-filters.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-default-filters.php	2013-07-31 01:46:02.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-default-filters.php	2013-09-25 11:21:09.000000000 -0500
***************
*** 18,24 ****
  add_action( 'init', 'maybe_add_existing_user_to_blog' );
  add_action( 'wpmu_new_user', 'newuser_notify_siteadmin' );
  add_action( 'wpmu_activate_user', 'add_new_user_to_blog', 10, 3 );
! add_action( 'sanitize_user', 'strtolower' );
  
  // Blogs
  add_filter( 'wpmu_validate_blog_signup', 'signup_nonce_check' );
--- 18,24 ----
  add_action( 'init', 'maybe_add_existing_user_to_blog' );
  add_action( 'wpmu_new_user', 'newuser_notify_siteadmin' );
  add_action( 'wpmu_activate_user', 'add_new_user_to_blog', 10, 3 );
! add_filter( 'sanitize_user', 'strtolower' );
  
  // Blogs
  add_filter( 'wpmu_validate_blog_signup', 'signup_nonce_check' );
***************
*** 37,44 ****
--- 37,51 ----
  add_action( 'publish_post', 'update_posts_count' );
  add_action( 'delete_post', '_update_blog_date_on_post_delete' );
  add_action( 'transition_post_status', '_update_blog_date_on_post_publish', 10, 3 );
+ 
+ // Counts
  add_action( 'admin_init', 'wp_schedule_update_network_counts');
  add_action( 'update_network_counts', 'wp_update_network_counts');
+ foreach ( array( 'user_register', 'deleted_user', 'wpmu_new_user', 'make_spam_user', 'make_ham_user' ) as $action )
+ 	add_action( $action, 'wp_maybe_update_network_user_counts' );
+ foreach ( array( 'make_spam_blog', 'make_ham_blog', 'archive_blog', 'unarchive_blog', 'make_delete_blog', 'make_undelete_blog' ) as $action )
+ 	add_action( $action, 'wp_maybe_update_network_site_counts' );
+ unset( $action );
  
  // Files
  add_filter( 'wp_upload_bits', 'upload_is_file_too_big' );
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-deprecated.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-deprecated.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-deprecated.php	2013-02-15 21:02:15.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-deprecated.php	2013-09-14 16:13:10.000000000 -0500
***************
*** 14,19 ****
--- 14,36 ----
   */
  
  /**
+  * Get the "dashboard blog", the blog where users without a blog edit their profile data.
+  * Dashboard blog functionality was removed in WordPress 3.1, replaced by the user admin.
+  *
+  * @since MU
+  * @deprecated 3.1.0
+  * @see get_blog_details()
+  * @return int
+  */
+ function get_dashboard_blog() {
+     _deprecated_function( __FUNCTION__, '3.1' );
+     if ( $blog = get_site_option( 'dashboard_blog' ) )
+         return get_blog_details( $blog );
+ 
+     return get_blog_details( $GLOBALS['current_site']->blog_id );
+ }
+ 
+ /**
   * @since MU
   * @deprecated 3.0.0
   * @deprecated Use wp_generate_password()
***************
*** 144,150 ****
   * @deprecated No alternative available. For performance reasons this function is not recommended.
   */
  function get_blog_list( $start = 0, $num = 10, $deprecated = '' ) {
! 	_deprecated_function( __FUNCTION__, '3.0' );
  
  	global $wpdb;
  	$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND public = '1' AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );
--- 161,167 ----
   * @deprecated No alternative available. For performance reasons this function is not recommended.
   */
  function get_blog_list( $start = 0, $num = 10, $deprecated = '' ) {
! 	_deprecated_function( __FUNCTION__, '3.0', 'wp_get_sites()' );
  
  	global $wpdb;
  	$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND public = '1' AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );
***************
*** 299,301 ****
--- 316,347 ----
  		return $user->ID;
  	return 0;
  }
+ 
+ /**
+  * Get a full blog URL, given a domain and a path.
+  *
+  * @since MU
+  * @deprecated 3.7.0
+  *
+  * @param string $domain
+  * @param string $path
+  * @return string
+  */
+ function get_blogaddress_by_domain( $domain, $path ) {
+ 	_deprecated_function( __FUNCTION__, '3.7' );
+ 
+ 	if ( is_subdomain_install() ) {
+ 		$url = "http://" . $domain.$path;
+ 	} else {
+ 		if ( $domain != $_SERVER['HTTP_HOST'] ) {
+ 			$blogname = substr( $domain, 0, strpos( $domain, '.' ) );
+ 			$url = 'http://' . substr( $domain, strpos( $domain, '.' ) + 1 ) . $path;
+ 			// we're not installing the main blog
+ 			if ( $blogname != 'www.' )
+ 				$url .= $blogname . '/';
+ 		} else { // main blog
+ 			$url = 'http://' . $domain . $path;
+ 		}
+ 	}
+ 	return esc_url_raw( $url );
+ }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-functions.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-functions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-functions.php	2013-08-30 23:37:03.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-functions.php	2013-10-22 00:48:09.000000000 -0500
***************
*** 17,24 ****
   * @return array Site and user count for the network.
   */
  function get_sitestats() {
- 	global $wpdb;
- 
  	$stats = array(
  		'blogs' => get_blog_count(),
  		'users' => get_user_count(),
--- 17,22 ----
***************
*** 138,147 ****
   *
   * @since MU 1.0
   *
!  * @param int $id Optional. A site_id.
   * @return int
   */
! function get_blog_count( $id = 0 ) {
  	return get_site_option( 'blog_count' );
  }
  
--- 136,148 ----
   *
   * @since MU 1.0
   *
!  * @param int $network_id Deprecated, not supported.
   * @return int
   */
! function get_blog_count( $network_id = 0 ) {
! 	if ( func_num_args() )
! 		_deprecated_argument( __FUNCTION__, '3.1' );
! 
  	return get_site_option( 'blog_count' );
  }
  
***************
*** 627,633 ****
   * @param string $user_email The user's email address.
   * @param array $meta By default, contains the requested privacy setting and lang_id.
   */
! function wpmu_signup_blog($domain, $path, $title, $user, $user_email, $meta = '') {
  	global $wpdb;
  
  	$key = substr( md5( time() . rand() . $domain ), 0, 16 );
--- 628,634 ----
   * @param string $user_email The user's email address.
   * @param array $meta By default, contains the requested privacy setting and lang_id.
   */
! function wpmu_signup_blog( $domain, $path, $title, $user, $user_email, $meta = array() )  {
  	global $wpdb;
  
  	$key = substr( md5( time() . rand() . $domain ), 0, 16 );
***************
*** 660,666 ****
   * @param string $user_email The user's email address.
   * @param array $meta By default, this is an empty array.
   */
! function wpmu_signup_user($user, $user_email, $meta = '') {
  	global $wpdb;
  
  	// Format data
--- 661,667 ----
   * @param string $user_email The user's email address.
   * @param array $meta By default, this is an empty array.
   */
! function wpmu_signup_user( $user, $user_email, $meta = array() ) {
  	global $wpdb;
  
  	// Format data
***************
*** 703,713 ****
   * @param string $title The site title.
   * @param string $user The user's login name.
   * @param string $user_email The user's email address.
-  * @param array $meta By default, contains the requested privacy setting and lang_id.
   * @param string $key The activation key created in wpmu_signup_blog()
   * @return bool
   */
! function wpmu_signup_blog_notification($domain, $path, $title, $user, $user_email, $key, $meta = '') {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_signup_blog_notification', $domain, $path, $title, $user, $user_email, $key, $meta) )
--- 704,714 ----
   * @param string $title The site title.
   * @param string $user The user's login name.
   * @param string $user_email The user's email address.
   * @param string $key The activation key created in wpmu_signup_blog()
+  * @param array $meta By default, contains the requested privacy setting and lang_id.
   * @return bool
   */
! function wpmu_signup_blog_notification( $domain, $path, $title, $user, $user_email, $key, $meta = array() ) {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_signup_blog_notification', $domain, $path, $title, $user, $user_email, $key, $meta) )
***************
*** 764,774 ****
   *
   * @param string $user The user's login name.
   * @param string $user_email The user's email address.
-  * @param array $meta By default, an empty array.
   * @param string $key The activation key created in wpmu_signup_user()
   * @return bool
   */
! function wpmu_signup_user_notification($user, $user_email, $key, $meta = '') {
  	if ( !apply_filters('wpmu_signup_user_notification', $user, $user_email, $key, $meta) )
  		return false;
  
--- 765,775 ----
   *
   * @param string $user The user's login name.
   * @param string $user_email The user's email address.
   * @param string $key The activation key created in wpmu_signup_user()
+  * @param array $meta By default, an empty array.
   * @return bool
   */
! function wpmu_signup_user_notification( $user, $user_email, $key, $meta = array() ) {
  	if ( !apply_filters('wpmu_signup_user_notification', $user, $user_email, $key, $meta) )
  		return false;
  
***************
*** 818,824 ****
   * @return array An array containing information about the activated user and/or blog
   */
  function wpmu_activate_signup($key) {
! 	global $wpdb, $current_site;
  
  	$signup = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->signups WHERE activation_key = %s", $key) );
  
--- 819,825 ----
   * @return array An array containing information about the activated user and/or blog
   */
  function wpmu_activate_signup($key) {
! 	global $wpdb;
  
  	$signup = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->signups WHERE activation_key = %s", $key) );
  
***************
*** 936,942 ****
   * @param int $site_id Optional. Only relevant on multi-network installs.
   * @return mixed Returns WP_Error object on failure, int $blog_id on success
   */
! function wpmu_create_blog($domain, $path, $title, $user_id, $meta = '', $site_id = 1) {
  	$domain = preg_replace( '/\s+/', '', sanitize_user( $domain, true ) );
  
  	if ( is_subdomain_install() )
--- 937,946 ----
   * @param int $site_id Optional. Only relevant on multi-network installs.
   * @return mixed Returns WP_Error object on failure, int $blog_id on success
   */
! function wpmu_create_blog( $domain, $path, $title, $user_id, $meta = array(), $site_id = 1 ) {
! 	$defaults = array( 'public' => 0 );
! 	$meta = wp_parse_args( $meta, $defaults );
! 
  	$domain = preg_replace( '/\s+/', '', sanitize_user( $domain, true ) );
  
  	if ( is_subdomain_install() )
***************
*** 964,978 ****
  
  	add_user_to_blog($blog_id, $user_id, 'administrator');
  
! 	if ( is_array($meta) ) foreach ($meta as $key => $value) {
! 		if ( $key == 'public' || $key == 'archived' || $key == 'mature' || $key == 'spam' || $key == 'deleted' || $key == 'lang_id' )
  			update_blog_status( $blog_id, $key, $value );
  		else
  			update_option( $key, $value );
  	}
  
  	add_option( 'WPLANG', get_site_option( 'WPLANG' ) );
! 	update_option( 'blog_public', (int)$meta['public'] );
  
  	if ( ! is_super_admin( $user_id ) && ! get_user_meta( $user_id, 'primary_blog', true ) )
  		update_user_meta( $user_id, 'primary_blog', $blog_id );
--- 968,982 ----
  
  	add_user_to_blog($blog_id, $user_id, 'administrator');
  
! 	foreach ( $meta as $key => $value ) {
! 		if ( in_array( $key, array( 'public', 'archived', 'mature', 'spam', 'deleted', 'lang_id' ) ) )
  			update_blog_status( $blog_id, $key, $value );
  		else
  			update_option( $key, $value );
  	}
  
  	add_option( 'WPLANG', get_site_option( 'WPLANG' ) );
! 	update_option( 'blog_public', (int) $meta['public'] );
  
  	if ( ! is_super_admin( $user_id ) && ! get_user_meta( $user_id, 'primary_blog', true ) )
  		update_user_meta( $user_id, 'primary_blog', $blog_id );
***************
*** 1098,1103 ****
--- 1102,1110 ----
  
  	$blog_id = $wpdb->insert_id;
  	refresh_blog_details( $blog_id );
+ 
+ 	wp_maybe_update_network_site_counts();
+ 
  	return $blog_id;
  }
  
***************
*** 1197,1203 ****
   * @param array $meta Optional. Not used in the default function, but is passed along to hooks for customization.
   * @return bool
   */
! function wpmu_welcome_notification($blog_id, $user_id, $password, $title, $meta = '') {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_welcome_notification', $blog_id, $user_id, $password, $title, $meta) )
--- 1204,1210 ----
   * @param array $meta Optional. Not used in the default function, but is passed along to hooks for customization.
   * @return bool
   */
! function wpmu_welcome_notification( $blog_id, $user_id, $password, $title, $meta = array() ) {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_welcome_notification', $blog_id, $user_id, $password, $title, $meta) )
***************
*** 1261,1267 ****
   * @param array $meta Optional. Not used in the default function, but is passed along to hooks for customization.
   * @return bool
   */
! function wpmu_welcome_user_notification($user_id, $password, $meta = '') {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_welcome_user_notification', $user_id, $password, $meta) )
--- 1268,1274 ----
   * @param array $meta Optional. Not used in the default function, but is passed along to hooks for customization.
   * @return bool
   */
! function wpmu_welcome_user_notification( $user_id, $password, $meta = array() ) {
  	global $current_site;
  
  	if ( !apply_filters('wpmu_welcome_user_notification', $user_id, $password, $meta) )
***************
*** 1297,1304 ****
  /**
   * Get the current site info.
   *
!  * Returns an object containing the ID, domain, path, and site_name
!  * of the site being viewed.
   *
   * @since MU
   *
--- 1304,1313 ----
  /**
   * Get the current site info.
   *
!  * Returns an object containing the 'id', 'domain', 'path', and 'site_name'
!  * properties of the site being viewed.
!  *
!  * @see wpmu_current_site()
   *
   * @since MU
   *
***************
*** 1470,1476 ****
  function wpmu_log_new_registrations( $blog_id, $user_id ) {
  	global $wpdb;
  	$user = get_userdata( (int) $user_id );
! 	$wpdb->insert( $wpdb->registration_log, array('email' => $user->user_email, 'IP' => preg_replace( '/[^0-9., ]/', '', wp_unslash( $_SERVER['REMOTE_ADDR'] ) ), 'blog_id' => $blog_id, 'date_registered' => current_time('mysql')) );
  }
  
  /**
--- 1479,1486 ----
  function wpmu_log_new_registrations( $blog_id, $user_id ) {
  	global $wpdb;
  	$user = get_userdata( (int) $user_id );
! 	if ( $user )
! 		$wpdb->insert( $wpdb->registration_log, array('email' => $user->user_email, 'IP' => preg_replace( '/[^0-9., ]/', '', wp_unslash( $_SERVER['REMOTE_ADDR'] ) ), 'blog_id' => $blog_id, 'date_registered' => current_time('mysql')) );
  }
  
  /**
***************
*** 1609,1615 ****
   * @since MU
   */
  function maybe_redirect_404() {
- 	global $current_site;
  	if ( is_main_site() && is_404() && defined( 'NOBLOGREDIRECT' ) && ( $destination = apply_filters( 'blog_redirect_404', NOBLOGREDIRECT ) ) ) {
  		if ( $destination == '%siteurl%' )
  			$destination = network_home_url();
--- 1619,1624 ----
***************
*** 1706,1719 ****
   * @since MU
   * @uses get_user_by()
   *
!  * @param string $user_login Optional. Defaults to current user.
   * @return bool
   */
! function is_user_spammy( $user_login = null ) {
! 	if ( $user_login )
! 		$user = get_user_by( 'login', $user_login );
! 	else
! 		$user = wp_get_current_user();
  
  	return $user && isset( $user->spam ) && 1 == $user->spam;
  }
--- 1715,1731 ----
   * @since MU
   * @uses get_user_by()
   *
!  * @param string|WP_User $user Optional. Defaults to current user. WP_User object,
!  * 	or user login name as a string.
   * @return bool
   */
! function is_user_spammy( $user = null ) {
!     if ( ! is_a( $user, 'WP_User' ) ) {
! 		if ( $user )
! 			$user = get_user_by( 'login', $user );
! 		else
! 			$user = wp_get_current_user();
! 	}
  
  	return $user && isset( $user->spam ) && 1 == $user->spam;
  }
***************
*** 1736,1756 ****
  add_action('update_option_blog_public', 'update_blog_public', 10, 2);
  
  /**
-  * Get the "dashboard blog", the blog where users without a blog edit their profile data.
-  *
-  * @since MU
-  * @uses get_blog_details()
-  *
-  * @return int
-  */
- function get_dashboard_blog() {
- 	if ( $blog = get_site_option( 'dashboard_blog' ) )
- 		return get_blog_details( $blog );
- 
- 	return get_blog_details( $GLOBALS['current_site']->blog_id );
- }
- 
- /**
   * Check whether a usermeta key has to do with the current blog.
   *
   * @since MU
--- 1748,1753 ----
***************
*** 1882,1891 ****
--- 1879,1961 ----
   *  @since 3.1.0
   */
  function wp_update_network_counts() {
+ 	wp_update_network_user_counts();
+ 	wp_update_network_site_counts();
+ }
+ 
+ /**
+  * Update the count of sites for the current network.
+  *
+  * If enabled through the 'enable_live_network_counts' filter, update the sites count
+  * on a network when a site is created or its status is updated.
+  *
+  * @since 3.7.0
+  *
+  * @uses wp_update_network_site_counts()
+  */
+ function wp_maybe_update_network_site_counts() {
+ 	$is_small_network = ! wp_is_large_network( 'sites' );
+ 
+ 	/**
+ 	 * Filter the decision to update network user and site counts in real time.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param bool   $small_network Based on wp_is_large_network( $context ).
+ 	 * @param string $context       Context. Either 'users' or 'sites'.
+ 	 */
+ 	if ( ! apply_filters( 'enable_live_network_counts', $is_small_network, 'sites' ) )
+ 		return;
+ 
+ 	wp_update_network_site_counts();
+ }
+ 
+ /**
+  * Update the network-wide users count.
+  *
+  * If enabled through the 'enable_live_network_counts' filter, update the users count
+  * on a network when a user is created or its status is updated.
+  *
+  * @since 3.7.0
+  *
+  * @uses wp_update_network_user_counts()
+  */
+ function wp_maybe_update_network_user_counts() {
+ 	$is_small_network = ! wp_is_large_network( 'users' );
+ 
+ 	/**
+ 	 * Filter the decision to update network user and site counts in real time.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param bool   $small_network Based on wp_is_large_network( $context ).
+ 	 * @param string $context       Context. Either 'users' or 'sites'.
+ 	 */
+ 	if ( ! apply_filters( 'enable_live_network_counts', $is_small_network, 'users' ) )
+ 		return;
+ 
+ 	wp_update_network_user_counts();
+ }
+ 
+ /**
+  * Update the network-wide site count.
+  *
+  * @since 3.7.0
+  */
+ function wp_update_network_site_counts() {
  	global $wpdb;
  
  	$count = $wpdb->get_var( $wpdb->prepare("SELECT COUNT(blog_id) as c FROM $wpdb->blogs WHERE site_id = %d AND spam = '0' AND deleted = '0' and archived = '0'", $wpdb->siteid) );
  	update_site_option( 'blog_count', $count );
+ }
+ 
+ /**
+  * Update the network-wide user count.
+  *
+  * @since 3.7.0
+  */
+ function wp_update_network_user_counts() {
+ 	global $wpdb;
  
  	$count = $wpdb->get_var( "SELECT COUNT(ID) as c FROM $wpdb->users WHERE spam = '0' AND deleted = '0'" );
  	update_site_option( 'user_count', $count );
***************
*** 1923,1931 ****
  		$space_allowed = get_site_option( 'blog_upload_space' );
  
  	if ( empty( $space_allowed ) || ! is_numeric( $space_allowed ) )
! 		$space_allowed = 50;
  
! 	return $space_allowed;
  }
  
  /**
--- 1993,2001 ----
  		$space_allowed = get_site_option( 'blog_upload_space' );
  
  	if ( empty( $space_allowed ) || ! is_numeric( $space_allowed ) )
! 		$space_allowed = 100;
  
! 	return apply_filters( 'get_space_allowed', $space_allowed );
  }
  
  /**
***************
*** 1993,1995 ****
--- 2063,2142 ----
  	$count = get_blog_count();
  	return apply_filters( 'wp_is_large_network', $count > 10000, 'sites', $count );
  }
+ 
+ 
+ /**
+  * Return an array of sites for a network or networks.
+  *
+  * @since 3.7.0
+  *
+  * @param array $args {
+  *     Array of default arguments. Optional.
+  *
+  *     @type int|array $network_id A network ID or array of network IDs. Set to null to retrieve sites
+  *                                 from all networks. Defaults to current network ID.
+  *     @type int       $public     Retrieve public or non-public sites. Default null, for any.
+  *     @type int       $archived   Retrieve archived or non-archived sites. Default null, for any.
+  *     @type int       $mature     Retrieve mature or non-mature sites. Default null, for any.
+  *     @type int       $spam       Retrieve spam or non-spam sites. Default null, for any.
+  *     @type int       $deleted    Retrieve deleted or non-deleted sites. Default null, for any.
+  *     @type int       $limit      Number of sites to limit the query to. Default 100.
+  *     @type int       $offset     Exclude the first x sites. Used in combination with the $limit parameter. Default 0.
+  * }
+  * @return array An empty array if the install is considered "large" via wp_is_large_network(). Otherwise,
+  *               an associative array of site data arrays, each containing the site (network) ID, blog ID,
+  *               site domain and path, dates registered and modified, and the language ID. Also, boolean
+  *               values for whether the site is public, archived, mature, spam, and/or deleted.
+  */
+ function wp_get_sites( $args = array() ) {
+ 	global $wpdb;
+ 
+ 	if ( wp_is_large_network() )
+ 		return array();
+ 
+ 	$defaults = array(
+ 		'network_id' => $wpdb->siteid,
+ 		'public'     => null,
+ 		'archived'   => null,
+ 		'mature'     => null,
+ 		'spam'       => null,
+ 		'deleted'    => null,
+ 		'limit'      => 100,
+ 		'offset'     => 0,
+ 	);
+ 
+ 	$args = wp_parse_args( $args, $defaults );
+ 
+ 	$query = "SELECT * FROM $wpdb->blogs WHERE 1=1 ";
+ 
+ 	if ( isset( $args['network_id'] ) && ( is_array( $args['network_id'] ) || is_numeric( $args['network_id'] ) ) ) {
+ 		$network_ids = implode( ',', wp_parse_id_list( $args['network_id'] ) );
+ 		$query .= "AND site_id IN ($network_ids) ";
+ 	}
+ 
+ 	if ( isset( $args['public'] ) )
+ 		$query .= $wpdb->prepare( "AND public = %d ", $args['public'] );
+ 
+ 	if ( isset( $args['archived'] ) )
+ 		$query .= $wpdb->prepare( "AND archived = %d ", $args['archived'] );
+ 
+ 	if ( isset( $args['mature'] ) )
+ 		$query .= $wpdb->prepare( "AND mature = %d ", $args['mature'] );
+ 
+ 	if ( isset( $args['spam'] ) )
+ 		$query .= $wpdb->prepare( "AND spam = %d ", $args['spam'] );
+ 
+ 	if ( isset( $args['deleted'] ) )
+ 		$query .= $wpdb->prepare( "AND deleted = %d ", $args['deleted'] );
+ 
+ 	if ( isset( $args['limit'] ) && $args['limit'] ) {
+ 		if ( isset( $args['offset'] ) && $args['offset'] )
+ 			$query .= $wpdb->prepare( "LIMIT %d , %d ", $args['offset'], $args['limit'] );
+ 		else
+ 			$query .= $wpdb->prepare( "LIMIT %d ", $args['limit'] );
+ 	}
+ 
+ 	$site_results = $wpdb->get_results( $query, ARRAY_A );
+ 
+ 	return $site_results;
+ }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-load.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-load.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-load.php	2013-06-26 14:33:58.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-load.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 73,80 ****
  
  	$blog = get_blog_details();
  
! 	// Allow short-circuiting
! 	$check = apply_filters('ms_site_check', null);
  	if ( null !== $check )
  		return true;
  
--- 73,86 ----
  
  	$blog = get_blog_details();
  
! 	/**
! 	 * Filter checking the status of the current blog.
! 	 *
! 	 * @since 1.2.1
! 	 *
! 	 * @param bool null Whether to skip the blog status check. Default null.
! 	*/
! 	$check = apply_filters( 'ms_site_check', null );
  	if ( null !== $check )
  		return true;
  
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/nav-menu.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/nav-menu.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/nav-menu.php	2013-07-05 10:41:46.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/nav-menu.php	2013-09-06 13:10:09.000000000 -0500
***************
*** 190,197 ****
  	$result = wp_delete_term( $menu->term_id, 'nav_menu' );
  
  	// Remove this menu from any locations.
! 	$locations = get_theme_mod( 'nav_menu_locations' );
! 	foreach ( (array) $locations as $location => $menu_id ) {
  		if ( $menu_id == $menu->term_id )
  			$locations[ $location ] = 0;
  	}
--- 190,197 ----
  	$result = wp_delete_term( $menu->term_id, 'nav_menu' );
  
  	// Remove this menu from any locations.
! 	$locations = get_nav_menu_locations();
! 	foreach ( $locations as $location => $menu_id ) {
  		if ( $menu_id == $menu->term_id )
  			$locations[ $location ] = 0;
  	}
***************
*** 476,483 ****
   * @return mixed $items array of menu items, else false.
   */
  function wp_get_nav_menu_items( $menu, $args = array() ) {
- 	global $_wp_using_ext_object_cache;
- 
  	$menu = wp_get_nav_menu_object( $menu );
  
  	if ( ! $menu )
--- 476,481 ----
***************
*** 504,510 ****
  		return false;
  
  	// Get all posts and terms at once to prime the caches
! 	if ( empty( $fetched[$menu->term_id] ) || $_wp_using_ext_object_cache ) {
  		$fetched[$menu->term_id] = true;
  		$posts = array();
  		$terms = array();
--- 502,508 ----
  		return false;
  
  	// Get all posts and terms at once to prime the caches
! 	if ( empty( $fetched[$menu->term_id] ) || wp_using_ext_object_cache() ) {
  		$fetched[$menu->term_id] = true;
  		$posts = array();
  		$terms = array();
***************
*** 685,693 ****
   *
   * @param int $object_id The ID of the original object.
   * @param string $object_type The type of object, such as "taxonomy" or "post_type."
   * @return array The array of menu item IDs; empty array if none;
   */
! function wp_get_associated_nav_menu_items( $object_id = 0, $object_type = 'post_type' ) {
  	$object_id = (int) $object_id;
  	$menu_item_ids = array();
  
--- 683,692 ----
   *
   * @param int $object_id The ID of the original object.
   * @param string $object_type The type of object, such as "taxonomy" or "post_type."
+  * @param string $taxonomy If $object_type is "taxonomy", $taxonomy is the name of the tax that $object_id belongs to
   * @return array The array of menu item IDs; empty array if none;
   */
! function wp_get_associated_nav_menu_items( $object_id = 0, $object_type = 'post_type', $taxonomy = '' ) {
  	$object_id = (int) $object_id;
  	$menu_item_ids = array();
  
***************
*** 703,709 ****
  	);
  	foreach( (array) $menu_items as $menu_item ) {
  		if ( isset( $menu_item->ID ) && is_nav_menu_item( $menu_item->ID ) ) {
! 			if ( get_post_meta( $menu_item->ID, '_menu_item_type', true ) != $object_type )
  				continue;
  
  			$menu_item_ids[] = (int) $menu_item->ID;
--- 702,709 ----
  	);
  	foreach( (array) $menu_items as $menu_item ) {
  		if ( isset( $menu_item->ID ) && is_nav_menu_item( $menu_item->ID ) ) {
! 			if ( get_post_meta( $menu_item->ID, '_menu_item_type', true ) !== $object_type ||
! 				get_post_meta( $menu_item->ID, '_menu_item_object', true ) !== $taxonomy )
  				continue;
  
  			$menu_item_ids[] = (int) $menu_item->ID;
***************
*** 741,750 ****
   * @param int $object_id The ID of the original object being trashed.
   *
   */
! function _wp_delete_tax_menu_item( $object_id = 0 ) {
  	$object_id = (int) $object_id;
  
! 	$menu_item_ids = wp_get_associated_nav_menu_items( $object_id, 'taxonomy' );
  
  	foreach( (array) $menu_item_ids as $menu_item_id ) {
  		wp_delete_post( $menu_item_id, true );
--- 741,750 ----
   * @param int $object_id The ID of the original object being trashed.
   *
   */
! function _wp_delete_tax_menu_item( $object_id = 0, $tt_id, $taxonomy ) {
  	$object_id = (int) $object_id;
  
! 	$menu_item_ids = wp_get_associated_nav_menu_items( $object_id, 'taxonomy', $taxonomy );
  
  	foreach( (array) $menu_item_ids as $menu_item_id ) {
  		wp_delete_post( $menu_item_id, true );
